---
title: Accessibility Inspector
slug: Tools/Accessibility_inspector
tags:
  - Accessibility
  - Accessibility inspector
  - DevTools
  - Guide
  - Tools
---
<div>{{ToolsSidebar}}</div>

<p class="summary">The Accessibility Inspector provides a means to access important information exposed to assistive technologies on the current page via the accessibility tree, allowing you to check what's missing or otherwise needs attention. This article takes you through the main features of the Accessibility Inspector and how to use it.</p>

<h2 id="A_very_brief_guide_to_accessibility">A (very) brief guide to accessibility</h2>

<p>Accessibility is the practice of making your websites usable by as many people as possible. This means trying your best to not lock anyone out of accessing information because of any disability they may have, or any other personal circumstances such as the device they are using, the speed of their network connection, or their geographic location or locale. You can find more extensive information in the <a href="/en-US/docs/Web/Accessibility">Accessibility</a> section of MDN Web Docs.</p>

<p>Here we are mainly talking about exposing information to people with visual disabilities — this is done via the <a href="https://www.smashingmagazine.com/2015/03/web-accessibility-with-accessibility-api/">accessibility APIs</a> available inside web browsers, which expose information on what roles the different elements on your page play (e.g., are they just text, or are they buttons, links, form elements, etc.?).</p>

<p>Semantic DOM elements have roles assigned to them by default that hint at what their purpose is. Sometimes, however, you need to use some non-semantic markup (e.g., {{htmlelement("div")}}s) to build a complex custom control, and the control won't have a default role that reflects its purpose. In such a situation, you can use <a href="/en-US/docs/Learn/Accessibility/WAI-ARIA_basics">WAI-ARIA</a> role attributes to provide your own roles.</p>

<p>Roles and other information exposed by browser accessibility APIs are presented in a hierarchical structure called the accessibility tree. This is a bit like the DOM tree, except that it contains a more limited set of elements and slightly different information about them.</p>

<p>Assistive technologies like screenreaders use this information to find out what's on a web page, tell their users what's there, and enable them to interact with the page. The Accessibility Inspector also uses this information to provide valuable accessibility debugging capabilities in the DevTools.</p>

<h2 id="Accessing_the_Accessibility_Inspector">Accessing the Accessibility Inspector</h2>

<p>When you first open any of the other Developer Tools, the accessibility features are turned off (unless you've already got them turned on in another browser tab, or got the Firefox accessibility engine started already, e.g., you might be a screenreader user or tester).</p>

<p>The accessibility inspector is automatically enabled when you do one of the following (before Firefox 79,  it had to be explicitly enabled):</p>

<ul>
 <li>Choose <strong>Accessibility</strong> in the <strong>Tools &gt; Web Developer</strong> menu.</li>
 <li>Select the <strong>Accessibility</strong> tab in the Developer Tools toolbox.</li>
 <li>Right-/<kbd>Ctrl</kbd>- click in the main browser window, and choose <strong>Inspect Accessibility Properties</strong> in the context menu.</li>
 <li>Right-click an item in the HTML pane of the <a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>, and choose <strong>Show Accessibility Properties</strong> in the context menu.</li>
</ul>

<p>Once activated, the accessibility engine remains running until you close the Developer Tools toolbox.</p>

<div class="notecard note">
<p><strong>Note</strong>: The accessibility engine runs in the background when the accessibility features are turned on. When enabled it may affect the metrics from other panels such as <a href="/en-US/docs/Tools/Memory">Memory</a> and <a href="/en-US/docs/Tools/Performance">Performance</a>, and have some impact on overall browser performance.</p>
</div>

<p>If you don't wish to allow the accessibility features to be automatically enabled, you can use the <a href="https://support.mozilla.org/en-US/kb/about-config-editor-firefox">Configuration Editor</a> (also known as <code>about:config</code>) to define the preference <code>devtools.accessibility.auto-init.enabled</code>, and set it to <code>False</code>.</p>

<p>If you don't wish to use the accessibility features at all, you can use the <a href="https://support.mozilla.org/en-US/kb/about-config-editor-firefox">Configuration Editor</a> to set the preference <code>devtools.accessibility.enabled</code> to <code>False</code>. If you do this, the methods listed above for activating the Accessibility Inspector do nothing.</p>

<h2 id="Features_of_the_Accessibility_panel">Features of the Accessibility panel</h2>

<p>The enabled accessibility panel looks like so:</p>

<p><img alt='Shows issue checker toolbar with "contrast and "text label" options' src="https://mdn.mozillademos.org/files/17437/Accessibility-Inspector-tabbing_order.png" style="border-style: solid; border-width: 1px; width: 1055px;"></p>

<p>On the left-hand side, there is a tree diagram representing all the items in the accessibility tree for the current page. Items with nested children have arrows that can be clicked to reveal the children, so you can move deeper into the hierarchy. Each item has two properties listed:</p>

<ul>
 <li><em>Role</em> — the role this item has on the page (e.g., <code>pushbutton</code>, or <code>footer</code>). This can be either a default role provided by the browser, or a role given to it via a WAI-ARIA <code>role</code> attribute.</li>
 <li><em>Name</em> — the name this item has on the page. The name depends on the element; for example, the name of most text elements is their <code>textContent</code>, whereas form elements' names are the contents of their associated {{htmlelement("label")}}.</li>
</ul>

<p>On the right-hand side, you can see further information about the currently selected item. The listed properties are as follows:</p>

<ul>
 <li><em>name</em> — the item's name, as described above.</li>
 <li><em>role</em> — the item's role, as described above.</li>
 <li><em>actions</em> — a list of actions that can be performed on the item, for example, a pushbutton would have "Press" listed, while a link would have "Jump" listed.</li>
 <li><em>value</em> — the value of the item. This can mean different things depending on the type of the item; for example, a form input (role: entry) would have a value of whatever is entered in the input, whereas a link's value would be the URL in the corresponding <code>&lt;a&gt;</code> element's <code>href</code>.</li>
 <li><em>DOMNode</em> — the type of DOM node that the item in the accessibility tree represents. You can click on the "target" icon that comes after it to select the node in the <a href="/en-US/docs/Tools/Page_Inspector">Page Inspector</a>. Hovering over the "target" icon highlights the DOM node in the page content.<br>
  <img alt="DOMNode property in accessibility inspector with target icon highlighted" src="https://mdn.mozillademos.org/files/16025/dom-node-target-icon.png" style="height: 55px; width: 294px;"></li>
 <li><em>description</em> — any further description provided on the element, usually by the content of a title attribute.</li>
 <li><em>keyboardShortcut</em> — any keyboard shortcut that is available to activate the element, as specified in an <code>accessKey</code> attribute. Note that this works correctly as of Firefox 62 ({{bug("1467381")}}).</li>
 <li><em>childCount</em> — the number of child items the current item has in the accessibility tree hierarchy.</li>
 <li><em>indexInParent</em> — an index value indicating what number child the item is, inside its parent. If the item is the first item inside its parent, it has a value of 0. If it is the second, it has a value of 1. And so on.</li>
 <li><em>states</em> — a list of the different accessibility-relevant states that can apply to the current item. For example, one of the links in one demo has states of focusable, linked, selectable text, opaque, enabled, and sensitive. For a full list of internal states, see <a href="/en-US/docs/Web/Accessibility/AT-APIs/Gecko/States">Gecko states</a>.</li>
 <li><em>relations</em> — a list of the accessiblity-relevant relationships between this item and other items. For example, in a form, an entry item could have a "labelled by" relation with a label item, which in turn has a "label for" relation to the entry item.</li>
 <li><em>attributes</em> — a list of all the accessibility-relevant attributes that are applied to the item. This can include style-related attributes such as margin-left and text-indent, and other useful states for accessibility information, such as draggable and level (e.g., what heading level is it, in the case of headings). For a full list of possible attributes, see <a href="/en-US/docs/Web/Accessibility/AT-APIs/Gecko/Attrs">Gecko object attributes</a>.</li>
</ul>

<div class="note">
<p><strong>Note</strong>: The exposed information is the same across all platforms — the inspector exposes Gecko's accessibility tree, rather than information from the platform accessibility layer.</p>
</div>

<h3 id="Keyboard_controls">Keyboard controls</h3>

<p>The <em>Accessibility</em> tab is fully keyboard-accessible:</p>

<ul>
 <li>You can tab between <em>Check for Issues</em>, <em>Simulate</em>, <em>Show tabbing order, </em>and left and right panels.</li>
 <li>When one of the panels is focused, you can move the focus up and down items using the up and down arrow keys, and use the left and right arrow keys to expand and collapse expandable rows (e.g., different hierarchy levels of the accessibility tree).</li>
</ul>

<h3 id="Print_accessibility_tree_to_JSON">Print accessibility tree to JSON</h3>

<p>You can print the contents of the accessibility tree to json by right-clicking on an entry in the Accessibility tab and selecting <strong>Print to JSON:</strong></p>

<p><strong><img alt="Print to JSON right-click menu in left panel" src="https://mdn.mozillademos.org/files/17438/Accessibility-Inspector-print_tree_to_json.png" style="border-style: solid; border-width: 1px; width: 1055px;"></strong></p>

<p>When you do, you will get a new tab with the selected accessibility tree loaded into the JSON viewer:</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16424/accessibility_json.png" style="display: block; margin: 0px auto; width: 800px;"></p>

<p>Once opened, you can save or copy the data as necessary. The JSON viewer can also show you the raw JSON data on a separate tab in the viewer.</p>

<h3 id="Show_web_page_tabbing_order">Show web page tabbing order</h3>

<p>People who are unable to navigate a page with the mouse or a trackpad can use the <kbd>tab</kbd> key to toggle through focussable items on the page (i.e. buttons, links, form controls). The order that items are focussed is one of the most important aspects of web accessibility, as it allows keyboard users to properly navigate a web page — if the tab order is incorrect, the page may be confusing!</p>

<p>Firefox 84 and later can enable a visual overlay showing the tabbing order. This provides a high-level overview of how the page will be navigated using the <kbd>tab</kbd> key, which may highlight problems more effectively than tabbing through the elements. The overlay is toggled on/off using the <strong>Show Tabbing Order</strong> checkbox.</p>

<p><img alt="Accessibility inspector and page with checkbox Show tab order selected." src="https://mdn.mozillademos.org/files/17440/Accessibility-Inspector-show_tab_order.png" style="border-style: solid; border-width: 1px; width: 993px;"></p>

<p>All focussable items have a numbered marker and the currently focussed item is highlighted in a different color. In some cases the marker may be hidden by other elements, as is true for items 1 and 2 in the in the page below.<br>
 <img alt="A page where some of the markers for selection items are hidden" src="https://mdn.mozillademos.org/files/17442/Accessibility-Inspector-hidden_items.png" style="width: 767px;"><br>
 These become visible in the overlay when the item is the current item.</p>

<p><img alt="Sshows a hidden selection item in the tabbing order overlay when it is selected." src="https://mdn.mozillademos.org/files/17443/Accessibility-Inspector-hidden_item_revealed.png"></p>

<div class="notecard note">
<p><strong>Note</strong>: The overlay reflects the tab order at the time that the checkbox is selected (i.e. it is not dynamic). If a user does anything that adds items to the tab order (e.g. opens a visual element that contains more links), these new items will not be reflected in the overlay until the Accessibility Inspector is re-launched.</p>
</div>

<h3 id="Check_for_accessibility_issues">Check for accessibility issues</h3>

<p>You can check for accessibility issues by clicking the drop-down menu next to: <strong>Check for issues</strong>. The available menu items include:</p>

<ul>
 <li><strong>None</strong> — Don't show the possible list of issues</li>
 <li><strong>All Issues</strong> — Check for all types of issues</li>
 <li><strong>Contrast</strong> — Check for <a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable/Color_contrast">issues with visual contrast</a></li>
 <li><strong>Keyboard</strong> — Check for <a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Keyboard">issues with navigating via a keyboard</a></li>
 <li><strong>Text Labels</strong> — Check for <a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Text_labels_and_names">issues with missing text labels</a></li>
</ul>

<p>When you one of the menu items, Firefox scans your document for the type of issues you selected. Depending on the size and complexity of your document, this may take a few seconds. When the scan is complete, the left side of the Accessibility Inspector panel displays only the items that have that type of issue. In the right side of the panel, the <em>Checks</em> subpanel lists the specific issue with the selected node. For each type of issue, there is a <strong>Learn more</strong> link to further information on <em>MDN Web Docs</em> about the issue.</p>

<p><br>
 <img alt="Accessibility Inspector - Showing the options when you select the Check for Issues button" src="https://mdn.mozillademos.org/files/17439/Accessibility-Inspector-check_for_issues.png" style="border-style: solid; border-width: 1px; width: 704px;"></p>

<p>The menu items act as toggles. Select the item to view that type of issue; select the item again to clear the display of issues of that type.</p>

<p>Issues with a particular item are always displayed in the <em>Checks</em> subpanel as you browse the tree. The <strong>Check for issues</strong> menuitems are a quick way to view all and only those items that have issues.</p>

<h3 id="Simulate">Simulate</h3>

<p>The Accessibility Inspector offers (as of Firefox 70), a <a href="/en-US/docs/Tools/Accessibility_inspector/Simulation">simulator</a> that lets you see what a web page would look like to users with various forms of <em>color vision deficiency</em> (better known as "color blindness"), as well as <em>contrast sensitivity loss</em>.</p>

<h2 id="Notable_related_features">Notable related features</h2>

<p>When the accessibility features are turned on, there are a number of useful additional features available in the DevTools, which are detailed below:</p>

<h3 id="Context_menu_options">Context menu options</h3>

<p>An extra context menu option is added, both for the general context menu on the web page when right/<kbd>Ctrl</kbd> + clicking a UI feature, and the HTML pane of the page inspector when right/<kbd>Ctrl</kbd> + clicking a DOM element:</p>

<p><img alt="context menu in the browser viewport, with a highlighted option: Inspect Accessibility Properties" src="https://mdn.mozillademos.org/files/16028/web-page-context-menu.png" style="border-style: solid; border-width: 1px; width: 1200px;"></p>

<p><img alt="context menu in the DOM inspector, with a highlighted option: Show Accessibility Properties" src="https://mdn.mozillademos.org/files/16020/dom-inspector-context-menu.png" style="border-style: solid; border-width: 1px; width: 1200px;"></p>

<p>When you choose the <em>Inspect Accessibility Properties</em>/<em>Show Accessibility Properties</em> context menu options, the <em>Accessibility</em> tab is immediately opened to show the corresponding accessibility tree item and its properties.</p>

<div class="note">
<p><strong>Note</strong>: Some DOM elements do not have accessibility properties — in that case, the <em>Inspect Accessibility Properties</em>/<em>Show Accessibility Properties</em> context menu item is grayed out.</p>
</div>

<h3 id="Highlighting_of_UI_items">Highlighting of UI items</h3>

<p>In the Accessibility tab, when the mouse hovers over accessibility items, you can see a semi-transparent highlight appear over the UI items they relate to, if appropriate. The role and name of the item will be shown in a small information bar along with color contrast information if appropriate. This is useful for determining how the items in the accessibility tree relate to the UI items on the actual page.</p>

<p>In the following example, you can see that the image has been highlighted and its role, graphic, name, "Road, Asphalt, Sky, Clouds, Fall", and the color contrast ratio, 3.46, appears in the information bar above it.</p>

<p><img alt="" src="https://mdn.mozillademos.org/files/16302/image_accessibility.png" style="border: 1px solid black; display: block; height: 347px; margin: 0px auto; width: 451px;"></p>

<h4 id="Color_contrast">Color contrast</h4>

<p>Contrast ratio information is particularly useful when you are designing the color palette for your website because if the contrast is not sufficient, readers with visual impairments such as low vision or color blindness will be unable to read the text. See <a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable/Color_contrast">Color contrast</a> for details about recommended contrast ratios.</p>

<p>For example:</p>

<p><img alt="A screenshot of colour contrast highlighter where text contrast if below the AA WCAG threshold." src="https://mdn.mozillademos.org/files/16459/Screen_Shot_2019-01-29_at_10.11.13.png" style="display: block; height: 237px; margin: 0px auto; width: 357px;"></p>

<p>The color contrast in the image above is 2.86, so potentially not enough contrast to make it easy to read. Notice the warning symbol that indicates that the contrast fails to meet the acceptable contrast ratio.</p>

<p>As of Firefox 65, viewing this information for some foreground text that has a complex background image (e.g. a gradient) gives you a range of color contrast values. For example:</p>

<p><img alt="A screenshot of colour contrast highlighter where for text over gradient background with contrast satisfying the AAA WCAG guidelines." src="https://mdn.mozillademos.org/files/16460/Screen_Shot_2019-01-29_at_10.21.07.png" style="display: block; margin: 0px auto; width: 1484px;"></p>

<p>In this example, the contrast ranges from 4.72 to 5.98. The numbers are followed by AAA and a checkmark in green, indicating that the large text has a contrast ratio of 4.5:1 or more, meeting the criteria for enhanced contrast, or Level AAA.</p>

<p>See <a href="/en-US/docs/Web/Accessibility/Understanding_WCAG/Perceivable/Color_contrast">Color contrast</a> for more information on color contrast.</p>

<h3 id="Accessibility_picker">Accessibility picker</h3>

<p>Like the element picker button on the <a href="/en-US/docs/Tools/Page_Inspector/How_to/Select_an_element#With_the_node_picker">Page Inspector</a>, the <em>Accessibility</em> tab's element picker button allows you to hover and select UI items on the current page  highlight objects in the accessibility tree.</p>

<p>The accessibility tab element picker looks slightly different from the Page Inspector HTML pane picker, as shown below:</p>

<p><img alt="highlighted dom inspector picker button, with a tooltip saying Pick an element from the page" src="https://mdn.mozillademos.org/files/16024/dom-inspector-picker.png" style="border-style: solid; border-width: 1px; width: 1716px;"></p>

<p><img alt="highlighted accessibility inspector button, with a tooltip saying Pick accessible object from the page" src="https://mdn.mozillademos.org/files/16023/accessibility-inspector-picker.png" style="border-style: solid; border-width: 1px; width: 1717px;"></p>

<p>When you "perform a pick", you see the accessibility object highlighted in the accessibility tree, and the picker is then deactivated. Note, however, that if you hold the <kbd>Shift</kbd> key down when "performing a pick", you can "preview" the accessibility object in the tree (and its properties in the right-hand pane), but then continue picking as many times as you like (the picker does not get cancelled) until you release the <kbd>Shift</kbd> key.</p>

<p>When the picker is activated, you can also deactivate it by pressing the picker button a second time, or pressing the <kbd>Esc</kbd> key.</p>

<h2 id="Typical_use_cases">Typical use cases</h2>

<p>The Accessibility Inspector is very useful for spotting accessibility problems at a glance. For a start, you can investigate items that don't have a proper text equivalent — images without <code>alt</code> text and form elements without proper labels have a <code>name</code> property of <code>null</code>, for example.</p>

<p><img alt="A form input highlighted in the UI, with information about it shown in the accessibility inspector to reveal that it has no label — it has a name property of null" src="https://mdn.mozillademos.org/files/16027/use-case-no-label.png" style="border-style: solid; border-width: 1px; width: 1182px;"></p>

<p>It is also very handy for verifying semantics — you can use the <em>Inspect Accessibility Properties</em> context menu option to quickly see whether an item has the correct role set on it (e.g., whether a button is really a button, or a link is really a link).</p>

<p><img alt="A UI element that looks like a button, with information about it shown in the accessibility inspector to reveal that it isn't a button, it is a section element. It has a name property of null" src="https://mdn.mozillademos.org/files/16026/use-case-fake-button.png" style="border-style: solid; border-width: 1px; width: 1182px;"></p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Learn/Accessibility">Accessibility tutorials</a></li>
 <li><a href="/en-US/docs/Web/Accessibility">Web accessibility overview</a></li>
 <li><a href="/en-US/docs/Learn/Tools_and_testing/Cross_browser_testing/Accessibility">Practical debugging information</a></li>
 <li><a href="/en-US/docs/Web/Accessibility/Understanding_WCAG">Understanding WCAG</a></li>
 <li><a href="/en-US/docs/Learn/Accessibility/WAI-ARIA_basics">WAI-ARIA basics</a></li>
 <li><a href="https://www.smashingmagazine.com/2015/03/web-accessibility-with-accessibility-api/">Accessibility APIs: A Key To Web Accessibility</a> by Léonie Watson</li>
</ul>
